hirom			; hirom addressing
;header			; Comment out if ROM has a header

; Configuration
!battleSongId = $24     ; Change only if you changed its value in the $C2BF3B table.
!bossSongId = $14       ; Change only if you changed its value in the $C2BF3B table.
!noSong = $FE           ; "null" song ID value.
!numSongBattle = $07    ; X - 1 battle songs, where X = 2^Y and Y <= 7.
!numSongBoss = $03      ; X - 1 boss songs, where X = 2^Y and Y <= 7.
						; In other words, these last two variable must equal 
						; $01, $03, $07, $0F, $1F, $3F or $7F for respectively 
						; 2, 4, 8, 16, 32, 64 or 128 songs.

; Code                  
org $C2BDB7
JSR randomness
BRA continue

; Code from above BRA up to here is skipped, since it is no longer needed
org $C2BDCD
continue:

org $C26469         ; New code. Change if you need to relocate the code.
					; I always use the same new code spot so make sure to manage properly your free space.
randomness:
LDA $C2BF3B,X       ; Load song ID
CMP #$FF      
BEQ return          ; Branch if we keep the current music playing
CMP #!battleSongId  ; Check if battle song
BEQ getBattle
CMP #!bossSongId	; Check if boss song
BEQ getBoss
BRA loadSong        ; otherwise just load the song

getBattle:
JSR $4B5A			; Get random number
AND #!numSongBattle ; Reduce it to a number from 0 to 7
TAX
LDA battleTable,X   ; Load the table song
CMP #!noSong		; Check if "null" value
BEQ getBattle       ; Get another random number if "null"
BRA loadSong        ; Otherwise load song

getBoss:
JSR	$4B5A			; Get random number
AND #!numSongBoss   ; Reduce it to a number from 0 to 3
TAX
LDA bossTable,X     ; Load the table song
CMP #!noSong		; Check if "null" value
BEQ getBoss         ; Get another random number if "null"
loadSong:           
STA $1301           ; Save song ID
LDA $11E4  
AND #$08                
BNE return    
JSL $C50004         ; Play song
return:
RTS

; It is more efficient to reduce a table to its half than 
; nullifying 50% or more of its entries.
battleTable:
db $24			; normal battle theme
db !noSong
db !noSong
db !noSong
db !noSong
db !noSong
db !noSong
db !noSong

bossTable:
db $14			; normal boss theme
db !noSong
db !noSong
db !noSong